curl --request GET \ --url 'https://api.onesignal.com/notifications/{message_id}?app_id={app_id}' \ --header 'Authorization: <authorization>'
import Onesignal from '@onesignal/node-onesignal';
const configuration = Onesignal.createConfiguration({
restApiKey: 'YOUR_REST_API_KEY',
});
const apiInstance = new Onesignal.DefaultApi(configuration);
// string
const appId: string = "YOUR_APP_ID";
// string
const notificationId: string = "b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88";
try {
const response = await apiInstance.getNotification(appId, notificationId);
console.log(response);
} catch (e) {
if (e instanceof Onesignal.ApiException) {
// `e.errorMessages` flattens any error-envelope shape to a `string[]`;
// the raw parsed body remains on `e.body`.
console.error("getNotification failed: HTTP " + e.code, e.errorMessages);
} else {
throw e;
}
}
import onesignal
from onesignal.api import default_api
from onesignal.models import *
from pprint import pprint
# See configuration.py for a list of all supported configuration parameters.
# Some of the OneSignal endpoints require ORGANIZATION_API_KEY token for authorization, while others require REST_API_KEY.
# We recommend adding both of them in the configuration page so that you will not need to figure it out yourself.
configuration = onesignal.Configuration(
rest_api_key = "YOUR_REST_API_KEY", # App REST API key required for most endpoints
organization_api_key = "YOUR_ORGANIZATION_API_KEY" # Organization key is only required for creating new apps and other top-level endpoints
)
# Enter a context with an instance of the API client
with onesignal.ApiClient(configuration) as api_client:
# Create an instance of the API class
api_instance = default_api.DefaultApi(api_client)
app_id = "YOUR_APP_ID"
notification_id = "b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88"
try:
# View notification
api_response = api_instance.get_notification(app_id, notification_id)
pprint(api_response)
except onesignal.ApiException as e:
print("Exception when calling DefaultApi->get_notification: %s\n" % e)
print("Status Code: %s" % e.status)
print("Response Body: %s" % e.body)
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure Bearer authorization: rest_api_key
$config = onesignal\client\Configuration::getDefaultConfiguration()
->setRestApiKeyToken('YOUR_REST_API_KEY')
->setOrganizationApiKeyToken('YOUR_ORGANIZATION_API_KEY');
$apiInstance = new onesignal\client\Api\DefaultApi(
// If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
// This is optional, `GuzzleHttp\Client` will be used as default.
new GuzzleHttp\Client(),
$config
);
$app_id = 'YOUR_APP_ID'; // string
$notification_id = 'b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88'; // string
try {
$result = $apiInstance->getNotification($app_id, $notification_id);
print_r($result);
} catch (\onesignal\client\ApiException $e) {
echo 'Exception when calling DefaultApi->getNotification: ', $e->getMessage(), PHP_EOL;
echo 'Status Code: ', $e->getCode(), PHP_EOL;
// getErrorMessages() flattens any error-envelope shape to a string[];
// the raw body remains on getResponseBody().
echo 'Error Messages: ', implode(', ', $e->getErrorMessages()), PHP_EOL;
echo 'Response Body: ', $e->getResponseBody(), PHP_EOL;
} catch (\Exception $e) {
echo 'Exception when calling DefaultApi->getNotification: ', $e->getMessage(), PHP_EOL;
}
package main
import (
"context"
"fmt"
"os"
"github.com/OneSignal/onesignal-go-api/v5"
)
func main() {
appId := "YOUR_APP_ID" // string |
notificationId := "b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88" // string |
configuration := onesignal.NewConfiguration()
apiClient := onesignal.NewAPIClient(configuration)
restAuth := context.WithValue(context.Background(), onesignal.RestApiKey, "YOUR_REST_API_KEY") // App REST API key required for most endpoints
resp, r, err := apiClient.DefaultApi.GetNotification(restAuth, notificationId).AppId(appId).Execute()
if err != nil {
fmt.Fprintf(os.Stderr, "Error when calling `DefaultApi.GetNotification``: %v\n", err)
fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
if apiErr, ok := err.(*onesignal.GenericOpenAPIError); ok {
// ErrorMessages() flattens any error-envelope shape to a []string;
// the raw body remains on Body().
fmt.Fprintf(os.Stderr, "Error Messages: %v\n", apiErr.ErrorMessages())
fmt.Fprintf(os.Stderr, "Response Body: %s\n", apiErr.Body())
}
}
// response from `GetNotification`: NotificationWithMeta
fmt.Fprintf(os.Stdout, "Response from `DefaultApi.GetNotification`: %v\n", resp)
}
require 'onesignal'
# setup authorization
OneSignal.configure do |config|
# Configure Bearer authorization: rest_api_key
config.rest_api_key = 'YOUR_REST_API_KEY'
end
api_instance = OneSignal::DefaultApi.new
app_id = 'YOUR_APP_ID' # String |
notification_id = 'b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88' # String |
begin
# View notification
result = api_instance.get_notification(app_id, notification_id)
p result
rescue OneSignal::ApiError => e
puts "Error when calling DefaultApi->get_notification: #{e}"
puts "Status Code: #{e.code}"
# `e.error_messages` flattens any error-envelope shape to an Array<String>;
# the raw body remains on `e.response_body`.
puts "Error Messages: #{e.error_messages}"
puts "Response Body: #{e.response_body}"
end
// Import classes:
import java.util.Arrays;
import java.util.List;
import com.onesignal.client.ApiClient;
import com.onesignal.client.ApiException;
import com.onesignal.client.Configuration;
import com.onesignal.client.auth.*;
import com.onesignal.client.model.*;
import com.onesignal.client.api.DefaultApi;
public class Example {
public static void main(String[] args) {
ApiClient defaultClient = Configuration.getDefaultApiClient();
defaultClient.setBasePath("https://api.onesignal.com");
// Configure HTTP bearer authorization: rest_api_key
HttpBearerAuth rest_api_key = (HttpBearerAuth) defaultClient.getAuthentication("rest_api_key");
rest_api_key.setBearerToken("YOUR_REST_API_KEY");
DefaultApi apiInstance = new DefaultApi(defaultClient);
String appId = "YOUR_APP_ID"; // String |
String notificationId = "b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88"; // String |
try {
NotificationWithMeta result = apiInstance.getNotification(appId, notificationId);
System.out.println(result);
} catch (ApiException e) {
System.err.println("Exception when calling DefaultApi#getNotification");
System.err.println("Status code: " + e.getCode());
// getErrorMessages() flattens any error-envelope shape to a List<String>;
// the raw body remains on getResponseBody().
System.err.println("Error messages: " + e.getErrorMessages());
System.err.println("Reason: " + e.getResponseBody());
System.err.println("Response headers: " + e.getResponseHeaders());
e.printStackTrace();
}
}
}
using System;
using System.Collections.Generic;
using System.Diagnostics;
using OneSignalApi.Api;
using OneSignalApi.Client;
using OneSignalApi.Model;
namespace Example
{
public class GetNotificationExample
{
public static void Main()
{
Configuration config = new Configuration();
config.BasePath = "https://api.onesignal.com";
// Configure Bearer token for authorization: rest_api_key
config.AccessToken = "YOUR_REST_API_KEY";
var apiInstance = new DefaultApi(config);
var appId = "YOUR_APP_ID"; // string |
var notificationId = "b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88"; // string |
try
{
// View notification
NotificationWithMeta result = apiInstance.GetNotification(appId, notificationId);
Debug.WriteLine(result);
}
catch (ApiException e)
{
Debug.Print("Exception when calling DefaultApi.GetNotification: " + e.Message );
Debug.Print("Status Code: "+ e.ErrorCode);
// e.ErrorMessages flattens any error-envelope shape to an IReadOnlyList<string>;
// the raw body remains on e.ErrorContent.
Debug.Print("Error Messages: " + string.Join(", ", e.ErrorMessages));
Debug.Print("Response Body: " + e.ErrorContent);
Debug.Print(e.StackTrace);
}
}
}
}
use onesignal_rust_api::apis::configuration::Configuration;
use onesignal_rust_api::apis::default_api;
#[tokio::main]
async fn main() {
let mut configuration = Configuration::new();
configuration.rest_api_key_token = Some("YOUR_REST_API_KEY".to_string());
// Realistic values are pulled from the spec's `example:` fields where present.
let app_id: &str = "YOUR_APP_ID";
let notification_id: &str = "b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88";
match default_api::get_notification(&configuration, app_id, notification_id).await {
Ok(resp) => println!("{:?}", resp),
Err(e @ onesignal_rust_api::apis::Error::ResponseError(_)) => {
// `e.error_messages()` flattens any error-envelope shape to a Vec<String>;
// the raw response remains on the ResponseError variant.
eprintln!("get_notification failed: {:?}", e.error_messages());
}
Err(e) => eprintln!("get_notification failed: {:?}", e),
}
}
View the details of a single message and the Outcomes associated with it.
GET
/
notifications
/
{message_id}
?app_id=
{app_id}
cURL
curl --request GET \ --url 'https://api.onesignal.com/notifications/{message_id}?app_id={app_id}' \ --header 'Authorization: <authorization>'
import Onesignal from '@onesignal/node-onesignal';
const configuration = Onesignal.createConfiguration({
restApiKey: 'YOUR_REST_API_KEY',
});
const apiInstance = new Onesignal.DefaultApi(configuration);
// string
const appId: string = "YOUR_APP_ID";
// string
const notificationId: string = "b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88";
try {
const response = await apiInstance.getNotification(appId, notificationId);
console.log(response);
} catch (e) {
if (e instanceof Onesignal.ApiException) {
// `e.errorMessages` flattens any error-envelope shape to a `string[]`;
// the raw parsed body remains on `e.body`.
console.error("getNotification failed: HTTP " + e.code, e.errorMessages);
} else {
throw e;
}
}
import onesignal
from onesignal.api import default_api
from onesignal.models import *
from pprint import pprint
# See configuration.py for a list of all supported configuration parameters.
# Some of the OneSignal endpoints require ORGANIZATION_API_KEY token for authorization, while others require REST_API_KEY.
# We recommend adding both of them in the configuration page so that you will not need to figure it out yourself.
configuration = onesignal.Configuration(
rest_api_key = "YOUR_REST_API_KEY", # App REST API key required for most endpoints
organization_api_key = "YOUR_ORGANIZATION_API_KEY" # Organization key is only required for creating new apps and other top-level endpoints
)
# Enter a context with an instance of the API client
with onesignal.ApiClient(configuration) as api_client:
# Create an instance of the API class
api_instance = default_api.DefaultApi(api_client)
app_id = "YOUR_APP_ID"
notification_id = "b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88"
try:
# View notification
api_response = api_instance.get_notification(app_id, notification_id)
pprint(api_response)
except onesignal.ApiException as e:
print("Exception when calling DefaultApi->get_notification: %s\n" % e)
print("Status Code: %s" % e.status)
print("Response Body: %s" % e.body)
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure Bearer authorization: rest_api_key
$config = onesignal\client\Configuration::getDefaultConfiguration()
->setRestApiKeyToken('YOUR_REST_API_KEY')
->setOrganizationApiKeyToken('YOUR_ORGANIZATION_API_KEY');
$apiInstance = new onesignal\client\Api\DefaultApi(
// If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
// This is optional, `GuzzleHttp\Client` will be used as default.
new GuzzleHttp\Client(),
$config
);
$app_id = 'YOUR_APP_ID'; // string
$notification_id = 'b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88'; // string
try {
$result = $apiInstance->getNotification($app_id, $notification_id);
print_r($result);
} catch (\onesignal\client\ApiException $e) {
echo 'Exception when calling DefaultApi->getNotification: ', $e->getMessage(), PHP_EOL;
echo 'Status Code: ', $e->getCode(), PHP_EOL;
// getErrorMessages() flattens any error-envelope shape to a string[];
// the raw body remains on getResponseBody().
echo 'Error Messages: ', implode(', ', $e->getErrorMessages()), PHP_EOL;
echo 'Response Body: ', $e->getResponseBody(), PHP_EOL;
} catch (\Exception $e) {
echo 'Exception when calling DefaultApi->getNotification: ', $e->getMessage(), PHP_EOL;
}
package main
import (
"context"
"fmt"
"os"
"github.com/OneSignal/onesignal-go-api/v5"
)
func main() {
appId := "YOUR_APP_ID" // string |
notificationId := "b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88" // string |
configuration := onesignal.NewConfiguration()
apiClient := onesignal.NewAPIClient(configuration)
restAuth := context.WithValue(context.Background(), onesignal.RestApiKey, "YOUR_REST_API_KEY") // App REST API key required for most endpoints
resp, r, err := apiClient.DefaultApi.GetNotification(restAuth, notificationId).AppId(appId).Execute()
if err != nil {
fmt.Fprintf(os.Stderr, "Error when calling `DefaultApi.GetNotification``: %v\n", err)
fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
if apiErr, ok := err.(*onesignal.GenericOpenAPIError); ok {
// ErrorMessages() flattens any error-envelope shape to a []string;
// the raw body remains on Body().
fmt.Fprintf(os.Stderr, "Error Messages: %v\n", apiErr.ErrorMessages())
fmt.Fprintf(os.Stderr, "Response Body: %s\n", apiErr.Body())
}
}
// response from `GetNotification`: NotificationWithMeta
fmt.Fprintf(os.Stdout, "Response from `DefaultApi.GetNotification`: %v\n", resp)
}
require 'onesignal'
# setup authorization
OneSignal.configure do |config|
# Configure Bearer authorization: rest_api_key
config.rest_api_key = 'YOUR_REST_API_KEY'
end
api_instance = OneSignal::DefaultApi.new
app_id = 'YOUR_APP_ID' # String |
notification_id = 'b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88' # String |
begin
# View notification
result = api_instance.get_notification(app_id, notification_id)
p result
rescue OneSignal::ApiError => e
puts "Error when calling DefaultApi->get_notification: #{e}"
puts "Status Code: #{e.code}"
# `e.error_messages` flattens any error-envelope shape to an Array<String>;
# the raw body remains on `e.response_body`.
puts "Error Messages: #{e.error_messages}"
puts "Response Body: #{e.response_body}"
end
// Import classes:
import java.util.Arrays;
import java.util.List;
import com.onesignal.client.ApiClient;
import com.onesignal.client.ApiException;
import com.onesignal.client.Configuration;
import com.onesignal.client.auth.*;
import com.onesignal.client.model.*;
import com.onesignal.client.api.DefaultApi;
public class Example {
public static void main(String[] args) {
ApiClient defaultClient = Configuration.getDefaultApiClient();
defaultClient.setBasePath("https://api.onesignal.com");
// Configure HTTP bearer authorization: rest_api_key
HttpBearerAuth rest_api_key = (HttpBearerAuth) defaultClient.getAuthentication("rest_api_key");
rest_api_key.setBearerToken("YOUR_REST_API_KEY");
DefaultApi apiInstance = new DefaultApi(defaultClient);
String appId = "YOUR_APP_ID"; // String |
String notificationId = "b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88"; // String |
try {
NotificationWithMeta result = apiInstance.getNotification(appId, notificationId);
System.out.println(result);
} catch (ApiException e) {
System.err.println("Exception when calling DefaultApi#getNotification");
System.err.println("Status code: " + e.getCode());
// getErrorMessages() flattens any error-envelope shape to a List<String>;
// the raw body remains on getResponseBody().
System.err.println("Error messages: " + e.getErrorMessages());
System.err.println("Reason: " + e.getResponseBody());
System.err.println("Response headers: " + e.getResponseHeaders());
e.printStackTrace();
}
}
}
using System;
using System.Collections.Generic;
using System.Diagnostics;
using OneSignalApi.Api;
using OneSignalApi.Client;
using OneSignalApi.Model;
namespace Example
{
public class GetNotificationExample
{
public static void Main()
{
Configuration config = new Configuration();
config.BasePath = "https://api.onesignal.com";
// Configure Bearer token for authorization: rest_api_key
config.AccessToken = "YOUR_REST_API_KEY";
var apiInstance = new DefaultApi(config);
var appId = "YOUR_APP_ID"; // string |
var notificationId = "b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88"; // string |
try
{
// View notification
NotificationWithMeta result = apiInstance.GetNotification(appId, notificationId);
Debug.WriteLine(result);
}
catch (ApiException e)
{
Debug.Print("Exception when calling DefaultApi.GetNotification: " + e.Message );
Debug.Print("Status Code: "+ e.ErrorCode);
// e.ErrorMessages flattens any error-envelope shape to an IReadOnlyList<string>;
// the raw body remains on e.ErrorContent.
Debug.Print("Error Messages: " + string.Join(", ", e.ErrorMessages));
Debug.Print("Response Body: " + e.ErrorContent);
Debug.Print(e.StackTrace);
}
}
}
}
use onesignal_rust_api::apis::configuration::Configuration;
use onesignal_rust_api::apis::default_api;
#[tokio::main]
async fn main() {
let mut configuration = Configuration::new();
configuration.rest_api_key_token = Some("YOUR_REST_API_KEY".to_string());
// Realistic values are pulled from the spec's `example:` fields where present.
let app_id: &str = "YOUR_APP_ID";
let notification_id: &str = "b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88";
match default_api::get_notification(&configuration, app_id, notification_id).await {
Ok(resp) => println!("{:?}", resp),
Err(e @ onesignal_rust_api::apis::Error::ResponseError(_)) => {
// `e.error_messages()` flattens any error-envelope shape to a Vec<String>;
// the raw response remains on the ResponseError variant.
eprintln!("get_notification failed: {:?}", e.error_messages());
}
Err(e) => eprintln!("get_notification failed: {:?}", e),
}
}
The View message API allows you to fetch data from a single push, email, or SMS message at a time. If you want to get multiple messages at a time, use the View messages API. In most cases, you will likely want to use Event Streams instead.Currently this API does not provide Journey-sent messages. See Journey analytics for details.Messages sent through the API are only accessible 30 days after creation; however, messages sent using the OneSignal dashboard are accessible for the app’s lifetime.See our Rate limits for details on how often you can pull your message data with this API.
How to use this API
This API is most commonly used when sending Transactional messages to individual users. The response of our Create message API has an id which corresponds to the message_id used in this request. You can store this message_id on your server and (after giving your users some time to interact with the message) pull the data if desired.For example, if you send a message targeting the include_aliases parameter, the response will include the aliases you set. If you send with the included_segments parameter, then the response will only provide the segments you set. When targeting segments or filters, you can use the Export audience activity CSV API to get the user event data.To view outcome data for the message, you must include the outcome_name parameter with the name of the outcome you want to fetch, along with the accompanying aggregation type (.count or .sum), for example: os__click.count. For more information on outcome definitions, see View Outcomes.
SMS and RCS analytics fields
For SMS messages, platform_delivery_stats.sms includes these analytics fields in addition to the standard delivery counts. RCS is a content type of the SMS channel, so RCS metrics appear in the sms object.
Field
Type
Description
provider_successful
integer
Messages the carrier confirmed as delivered, over SMS and RCS combined.
sms_delivered
integer
Messages delivered as SMS or MMS, including SMS fallbacks of RCS messages.
rcs_delivered
integer
Messages delivered over RCS.
rcs_read
integer
RCS read receipts received.
clicks
integer
Trackable link clicks plus RCS link taps, including repeats. Reads 0 for an SMS message with no trackable link and no RCS taps.
unique_clicks
integer
Unique trackable link clicks (counted once per browser) plus subscriptions that tapped an RCS link (counted once per subscription).
rcs_clicked
integer
RCS link taps, including repeats.
rcs_unique_clicked
integer
Subscriptions that tapped at least one RCS link.
rcs_replied
integer
RCS keyword reply button taps, including repeats. Typed SMS replies are not counted.
rcs_unique_replied
integer
Subscriptions that tapped at least one RCS keyword reply button.
rcs_clicked, rcs_unique_clicked, rcs_replied, and rcs_unique_replied are returned only for apps with RCS access. For other apps, these fields are left out of the response rather than returned as 0.To get SMS-only clicks, subtract rcs_clicked from clicks, or rcs_unique_clicked from unique_clicks. A recipient’s clicks come from either trackable links or RCS taps, never both, because RCS content does not support trackable links.
RCS button activity
For apps with RCS access, the response for an SMS message also includes a top-level rcs_element_activity array with one entry per RCS button. Only this endpoint returns rcs_element_activity. View messages does not.
Field
Type
Description
id
string
The button’s action ID.
label
string
The button text. Falls back to the action ID when the message content can’t be found, for example after the message was deleted.
card_index
integer or null
The button’s card position in a carousel, starting at 0. null for a standalone card.
action
string
The button type: url, phone_number, or quick_reply.
url
string or null
The link destination for a url button.
phone_number
string or null
The phone number for a phone_number button.
value
string or null
The reply keyword for a quick_reply button.
clicked
integer
Total taps on a url or phone_number button, including repeats.
replied
integer
Total taps on a quick_reply button, including repeats.
Button activity counts are totals only. There are no per-button unique counts. A button’s total can be lower than the message-level total.
The identifier of the message in UUID v4 format. Get this id in the response of your Create Message API request, the View Messages API, and in your OneSignal dashboard Message Reports.
Query Parameters
app_id
string
default:YOUR_APP_ID
required
Your OneSignal App ID in UUID v4 format. See Keys & IDs.
outcome_names
string[]
The name and aggregation type of the outcome(s) you want to fetch. Example: my_outcome.count or my_outcome.sum. For clicks, use os__click.count. For confirmed deliveries, use os__confirmed_delivery.count. For session duration, use os__session_duration.count.
outcome_time_range
enum<string>
default:1h
Time range for the returned data. Available values: 1h (1 hour), 1d (1 day), 1mo (1 month)
Available options:
1h,
1d,
1mo
outcome_platforms
string
default:0,1,2,5,8,11,14,17
The platforms in which you want to pull the data represented as the device_type integer.
outcome_attribution
enum<string>
default:total
Attribution type for the outcomes.
Available options:
direct,
influenced,
unattributed,
total
Response
200
Returns all message properties set. See the Push notifications, Email, and/or SMS Message Create APIs for all properties. Most commonly used properties for this endpoint are listed.
app_id
string
Your OneSignal App ID in UUID v4 format. See Keys & IDs.
big_picture
string
The URL of the image set in the push notification.
canceled
boolean
Whether the message was canceled.
chrome_web_icon
string
The URL of the icon set in the push notification.
chrome_web_image
string
The URL of the image set in the push notification.
name
string
An internal name you set to help organize and track messages. Not shown to recipients. Maximum 128 characters.
The JSON data set in the push notification if applicable.
delayed_option
string
The per-user delay option set for the message.
delivery_time_of_day
string
The delivery time of day set for the message if delayed_option is timezone.
remaining
integer
The number of messages that have not been sent yet. If null, then the system is still processing the audience, try again later.
errored
integer
The number of times the message errored.
excluded_segments
array
The segments excluded from the message if applicable.
failed
integer
The number of subscriptions reported unsubscribed for the message.
global_image
string
The URL of the image set in the push notification.
headings
object
The title of the push notification.
id
string
The identifier of the message in UUID v4 format.
included_segments
array
The segments included in the message if applicable.
ios_badgeCount
integer
The badge count set for the message if applicable.
ios_badgeType
string
The badge type set for the message if applicable.
queued_at
integer
Unix timestamp of when the message was created.
send_after
integer
Unix timestamp of when the message delivery was scheduled to begin.
completed_at
integer
Unix timestamp of when the message delivery was completed. The delivery duration from start to finish can be calculated with completed_at - send_after.
successful
integer
The number of messages successfully delivered to the push, email, or SMS servers.
The template ID in UUID v4 format set for the message if applicable. See Templates.
url
string
The URL of the push notification.
web_url
string
The URL of the push notification for web push subscriptions.
app_url
string
The URL of the push notification for mobile subscriptions.
platform_delivery_stats
object
The successful, errored, failed, converted, received and frequency cap counts for each platform applicable.
throttle_rate_per_minute
number
The throttle rate of the push notification if applicable.
fcap_status
string
The frequency cap status of the push notification if applicable.
outcomes
object
The id, value, and aggregation type of the outcome set in the request.
kind
enum<string>
Present when this message is an Auto Warm Up campaign.
Available options:
warmup
email_warm_up
object
The Auto Warm Up campaign's stage schedule, strategy, and live status. Present only when kind is warmup. See Auto Warm Up.
Show child attributes
Was this page helpful?
{"docsConfig":{"theme":"mint","$schema":"https://mintlify.com/docs.json","name":"OneSignal Documentation","description":"OneSignal is a platform for sending push notifications, emails, in-app messages, and SMS campaigns via a single API, Journey Builder, and a dashboard.","colors":{"primary":"#3A3DB3","light":"#E54B4D","dark":"#3A3DB3"},"logo":{"light":"https://mintcdn.com/onesignal/yJcueeDCO7UpHnnY/logo/OneSignal-Logo.svg?fit=max\u0026auto=format\u0026n=yJcueeDCO7UpHnnY\u0026q=85\u0026s=1fcfb6fef6d820fd9d99c74850711107","dark":"https://mintcdn.com/onesignal/s4WC_KzLxf8ornqq/logo/OneSignal-Logo-White.svg?fit=max\u0026auto=format\u0026n=s4WC_KzLxf8ornqq\u0026q=85\u0026s=2573a53b5aea961e18c82b3af8f31925"},"favicon":"https://mintcdn.com/onesignal/SGduBFHpiRdg5l6h/favicon.ico?fit=max\u0026auto=format\u0026n=SGduBFHpiRdg5l6h\u0026q=85\u0026s=c0a99fadc0553c658a83741c5611cef4","api":{"examples":{"languages":["curl","typescript","python","php","go","ruby","java","csharp","rust"],"autogenerate":true}},"navbar":{"links":[{"href":"mailto:support@onesignal.com","label":"Support"}],"primary":{"type":"button","label":"Dashboard","href":"https://dashboard.onesignal.com"}},"footer":{"socials":{"github":"https://github.com/OneSignal","linkedin":"https://linkedin.com/company/onesignal","youtube":"https://www.youtube.com/@onesignalofficial/playlists"}},"seo":{"metatags":{"apple-mobile-web-app-title":"OneSignal Docs"}},"fonts":{"family":"Nunito Sans"},"styling":{"eyebrows":"breadcrumbs","latex":true},"integrations":{"ga4":{"measurementId":"G-2DGWL0VYP5"},"posthog":{"apiKey":"phc_vZpvE0f5eyzcOt30FHer34yddVmNdo9kmlMVRBzLMtn","apiHost":"https://eu.i.posthog.com","sessionRecording":true}},"contextual":{"options":["copy","view","chatgpt","claude"],"display":"header"},"navigation":{"languages":[{"language":"en","href":"docs/en/home"},{"language":"cn","href":"docs/cn/home"},{"language":"ko","href":"docs/ko/home"},{"language":"ja","href":"docs/ja/home"},{"language":"tr","href":"docs/tr/home"},{"language":"pt-BR","href":"docs/pt-BR/home"},{"language":"es","href":"docs/es/home"},{"language":"fr","href":"docs/fr/home"}]}},"deployment":{"deploymentMetadataValue":{"subdomain":"onesignal","hasAudioNarration":false,"actualSubdomain":"onesignal","customDomains":["documentation.onesignal.com"],"gitSource":{"type":"github","owner":"onesignal","repo":"mintlify-docs","deployBranch":"main","contentDirectory":"","isPrivate":true,"mountPath":"","label":""},"feedback":{"thumbs":true},"entitlements":{"AI_CHAT":{"status":"ENABLED"},"WEB_MCP":{"status":"ENABLED"},"NARRATION":{"status":"ENABLED"}},"buildId":"6af775c19740c9df2d1d915c","clientVersion":"0.0.4142","searchFilterCounts":[{"language":"en","tag":"User Guides","count":205},{"language":"es","tag":"Guías del Usuario","count":179},{"language":"fr","tag":"Guides utilisateur","count":179},{"language":"ja","tag":"ユーザーガイド","count":179},{"language":"ko","tag":"사용자 가이드","count":179},{"language":"pt-BR","tag":"Guia do Usuário","count":179},{"language":"tr","tag":"Kullanıcı Kılavuzları","count":179},{"language":"cn","tag":"用户指南","count":177},{"language":"en","tag":"Message channels","count":91},{"language":"es","tag":"Canales de mensajería","count":85},{"language":"fr","tag":"Canaux de messagerie","count":85},{"language":"ja","tag":"メッセージングチャネル","count":85},{"language":"ko","tag":"메시지 채널","count":85},{"language":"pt-BR","tag":"Canais de mensagem","count":85},{"language":"tr","tag":"Mesaj kanalları","count":85},{"language":"cn","tag":"消息渠道","count":84},{"language":"default","tag":"API Reference","count":68},{"language":"default","tag":"API reference","count":64},{"language":"en","tag":"Analytics \u0026 Integrations","count":53},{"language":"es","tag":"Analítica \u0026 Integraciones","count":52},{"language":"fr","tag":"Analyses et intégrations","count":52},{"language":"ja","tag":"分析 \u0026 統合","count":52},{"language":"ko","tag":"분석 \u0026 통합","count":52},{"language":"pt-BR","tag":"Análises \u0026 Integrações","count":52},{"language":"tr","tag":"Analitik ve Entegrasyonlar","count":52},{"language":"cn","tag":"分析和集成","count":51},{"language":"cn","tag":"开发者指南","count":49},{"language":"es","tag":"Guías del desarrollador","count":49},{"language":"fr","tag":"Guides développeur","count":49},{"language":"ja","tag":"開発者ガイド","count":49},{"language":"ko","tag":"개발자 가이드","count":49},{"language":"tr","tag":"Geliştirici Kılavuzları","count":49},{"language":"en","tag":"Developer Guides","count":48},{"language":"pt-BR","tag":"Guia de desenvolvedor","count":48},{"language":"en","tag":"Integrations","count":37},{"language":"es","tag":"Integraciones","count":37},{"language":"fr","tag":"Intégrations","count":37},{"language":"ja","tag":"統合","count":37},{"language":"ko","tag":"통합","count":37},{"language":"pt-BR","tag":"Integrações","count":37},{"language":"tr","tag":"Entegrasyonlar","count":37},{"language":"cn","tag":"集成","count":36},{"language":"en","tag":"Tutorials","count":35},{"language":"cn","tag":"推送通知","count":31},{"language":"cn","tag":"OneSignal 作为目的地","count":31},{"language":"en","tag":"Push","count":31},{"language":"en","tag":"OneSignal as destination","count":31},{"language":"es","tag":"Push notificaciones","count":31},{"language":"es","tag":"OneSignal como destino","count":31},{"language":"fr","tag":"Push","count":31},{"language":"fr","tag":"OneSignal comme destination","count":31},{"language":"ja","tag":"プッシュ通知","count":31},{"language":"ja","tag":"OneSignal as 宛先","count":31},{"language":"ko","tag":"푸시","count":31},{"language":"ko","tag":"OneSignal을 데이터 목적지로 사용","count":31},{"language":"pt-BR","tag":"Push notificações","count":31},{"language":"pt-BR","tag":"OneSignal como destino","count":31},{"language":"tr","tag":"Anlık bildirimler","count":31},{"language":"tr","tag":"OneSignal hedef","count":31},{"language":"cn","tag":"移动SDK","count":26},{"language":"en","tag":"Mobile SDKs","count":26},{"language":"es","tag":"SDKs móviles","count":26},{"language":"fr","tag":"SDK mobiles","count":26},{"language":"ja","tag":"モバイルSDK","count":26},{"language":"ko","tag":"모바일 SDKs","count":26},{"language":"pt-BR","tag":"SDKs móveis","count":26},{"language":"tr","tag":"Mobil SDK'lar","count":26},{"language":"cn","tag":"教程","count":24},{"language":"es","tag":"Tutoriales","count":24},{"language":"fr","tag":"Tutoriels","count":24},{"language":"ja","tag":"チュートリアル","count":24},{"language":"ko","tag":"튜토리얼","count":24},{"language":"pt-BR","tag":"Tutoriais","count":24},{"language":"tr","tag":"Eğitimler","count":24},{"language":"cn","tag":"移动SDK设置","count":19},{"language":"en","tag":"Mobile SDK setup","count":19},{"language":"es","tag":"Configuración del SDK móvil","count":19},{"language":"fr","tag":"Configuration SDK mobile","count":19},{"language":"ja","tag":"モバイルSDKセットアップ","count":19},{"language":"ko","tag":"모바일 SDK 설정","count":19},{"language":"pt-BR","tag":"Configuração do SDK móvel","count":19},{"language":"tr","tag":"Mobil SDK kurulumu","count":19},{"language":"default","tag":"Messages","count":9},{"language":"default","tag":"Users","count":9},{"language":"default","tag":"Organization","count":9},{"language":"default","tag":"Journeys","count":8},{"language":"default","tag":"Deprecated","count":6},{"language":"default","tag":"Templates","count":6},{"language":"default","tag":"Subscriptions","count":6},{"language":"default","tag":"Segments","count":5}]},"assistantConfig":{"enableStarterQuestions":false,"deflection":{"enabled":true,"email":"support@onesignal.com","showHelpButton":true}},"basePath":"","hasChatPermissions":true,"hasWebMcpPermissions":true,"toggles":[{"name":"kill-isr","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-rbac-roles","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-mintlify-slack","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-integrations-settings","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"rbac-expansion","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-pr-grouping","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-prefix","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"analytics-v7","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"user-flows-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"no-publish-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-onboarding","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving-live","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"stripTemperatureMiddleware","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"support-platform-pylon-zendesk","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"instant-rollback","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications-server","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-fable","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fixed-ai-action-pricing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automation-resolve-merge-conflict","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"scoped-publishing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"mintql","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"page-level-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-version-history-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-page-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"full-page-search","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workspace-projects","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"assistant-v5","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fork-pr-previews","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"revalidation-jwt","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-sso-scim","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"hobby-abuse-scan","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"dashboard-inbox","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-signup","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"turbopuffer-dual-write","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-enabled","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"approve-review-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-metadata","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"sso-setup-deadline-banner","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"turbopuffer-serve","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"live-agents","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"llms-txt-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false}],"googleFontsInlined":true},"customCss":[],"page":{"pagePath":"reference/view-message","slug":"/reference/view-message","pageMetadata":{"title":"View message","openapi":"GET /notifications/{message_id}?app_id={app_id}","keywords":["get message","message stats API","message_id","platform_delivery_stats","outcome_name","RCS analytics","rcs_element_activity","delivery stats"],"description":"View the details of a single message and the Outcomes associated with it.","href":"/reference/view-message"},"description":{"compiledSource":"\"use strict\";\nconst {jsx: _jsx} = arguments[0];\nconst {useMDXComponents: _provideComponents} = arguments[0];\nfunction _createMdxContent(props) {\n const _components = {\n p: \"p\",\n ..._provideComponents(),\n ...props.components\n };\n return _jsx(_components.p, {\n children: \"View the details of a single message and the Outcomes associated with it.\"\n });\n}\nfunction MDXContent(props = {}) {\n const {wrapper: MDXLayout} = {\n ..._provideComponents(),\n ...props.components\n };\n return MDXLayout ? _jsx(MDXLayout, {\n ...props,\n children: _jsx(_createMdxContent, {\n ...props\n })\n }) : _createMdxContent(props);\n}\nreturn {\n default: MDXContent\n};\n","frontmatter":{},"scope":{}},"pageType":"default","mdx":{"mdxSource":{"compiledSource":"\"use strict\";const{Fragment:_Fragment,jsx:_jsx,jsxs:_jsxs}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){const _components={a:`a`,code:`code`,hr:`hr`,p:`p`,strong:`strong`,tbody:`tbody`,td:`td`,th:`th`,thead:`thead`,tr:`tr`,..._provideComponents(),...props.components},{Heading,Table}=_components;if(!Heading)_missingMdxReference(`Heading`,true);if(!Table)_missingMdxReference(`Table`,true);return _jsxs(_Fragment,{children:[_jsx(Heading,{level:`2`,id:`overview`,children:`Overview`}),`\n`,_jsxs(_components.p,{children:[`The View message API allows you to fetch data from a single push, email, or SMS message at a time. If you want to get multiple messages at a time, use the `,_jsx(_components.a,{href:`/reference/view-messages`,children:`View messages`}),` API. In most cases, you will likely want to use `,_jsx(_components.a,{href:`/docs/en/event-streams`,children:`Event Streams`}),` instead.`]}),`\n`,_jsxs(_components.p,{children:[`Currently this API does not provide Journey-sent messages. See `,_jsx(_components.a,{href:`/docs/en/journeys-analytics`,children:`Journey analytics`}),` for details.`]}),`\n`,_jsxs(_components.p,{children:[`Messages sent through the API are only `,_jsx(_components.strong,{children:`accessible 30 days after creation`}),`; however, messages sent using the OneSignal dashboard are accessible for the app’s lifetime.`]}),`\n`,_jsxs(_components.p,{children:[`See our `,_jsx(_components.a,{href:`/reference/rate-limits`,children:`Rate limits`}),` for details on how often you can pull your message data with this API.`]}),`\n`,_jsx(_components.hr,{}),`\n`,_jsx(Heading,{level:`2`,id:`how-to-use-this-api`,children:`How to use this API`}),`\n`,_jsxs(_components.p,{children:[`This API is most commonly used when sending `,_jsx(_components.a,{href:`/docs/en/transactional-messages`,children:`Transactional messages`}),` to individual users. The response of our Create message API has an `,_jsx(_components.code,{children:`id`}),` which corresponds to the `,_jsx(_components.code,{children:`message_id`}),` used in this request. You can store this `,_jsx(_components.code,{children:`message_id`}),` on your server and (after giving your users some time to interact with the message) pull the data if desired.`]}),`\n`,_jsxs(_components.p,{children:[`For example, if you send a message targeting the `,_jsx(_components.code,{children:`include_aliases`}),` parameter, the response will include the aliases you set. If you send with the `,_jsx(_components.code,{children:`included_segments`}),` parameter, then the response will only provide the segments you set. When targeting segments or filters, you can use the `,_jsx(_components.a,{href:`/reference/export-csv-of-events`,children:`Export audience activity CSV`}),` API to get the user event data.`]}),`\n`,_jsxs(_components.p,{children:[`To view outcome data for the message, you must include the `,_jsx(_components.code,{children:`outcome_name`}),` parameter with the name of the outcome you want to fetch, along with the accompanying aggregation type (.count or .sum), for example: `,_jsx(_components.code,{children:`os__click.count`}),`. For more information on outcome definitions, see `,_jsx(_components.a,{href:`/reference/view-outcomes`,children:`View Outcomes`}),`.`]}),`\n`,_jsx(_components.hr,{}),`\n`,_jsx(Heading,{level:`2`,id:`sms-and-rcs-analytics-fields`,children:`SMS and RCS analytics fields`}),`\n`,_jsxs(_components.p,{children:[`For SMS messages, `,_jsx(_components.code,{children:`platform_delivery_stats.sms`}),` includes these analytics fields in addition to the standard delivery counts. RCS is a content type of the SMS channel, so RCS metrics appear in the `,_jsx(_components.code,{children:`sms`}),` object.`]}),`\n`,_jsxs(Table,{children:[_jsx(_components.thead,{children:_jsxs(_components.tr,{children:[_jsx(_components.th,{children:`Field`}),_jsx(_components.th,{children:`Type`}),_jsx(_components.th,{children:`Description`})]})}),_jsxs(_components.tbody,{children:[_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`provider_successful`})}),_jsx(_components.td,{children:`integer`}),_jsx(_components.td,{children:`Messages the carrier confirmed as delivered, over SMS and RCS combined.`})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`sms_delivered`})}),_jsx(_components.td,{children:`integer`}),_jsx(_components.td,{children:`Messages delivered as SMS or MMS, including SMS fallbacks of RCS messages.`})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`rcs_delivered`})}),_jsx(_components.td,{children:`integer`}),_jsx(_components.td,{children:`Messages delivered over RCS.`})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`rcs_read`})}),_jsx(_components.td,{children:`integer`}),_jsx(_components.td,{children:`RCS read receipts received.`})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`clicks`})}),_jsx(_components.td,{children:`integer`}),_jsxs(_components.td,{children:[`Trackable link clicks plus RCS link taps, including repeats. Reads `,_jsx(_components.code,{children:`0`}),` for an SMS message with no trackable link and no RCS taps.`]})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`unique_clicks`})}),_jsx(_components.td,{children:`integer`}),_jsx(_components.td,{children:`Unique trackable link clicks (counted once per browser) plus subscriptions that tapped an RCS link (counted once per subscription).`})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`rcs_clicked`})}),_jsx(_components.td,{children:`integer`}),_jsx(_components.td,{children:`RCS link taps, including repeats.`})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`rcs_unique_clicked`})}),_jsx(_components.td,{children:`integer`}),_jsx(_components.td,{children:`Subscriptions that tapped at least one RCS link.`})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`rcs_replied`})}),_jsx(_components.td,{children:`integer`}),_jsx(_components.td,{children:`RCS keyword reply button taps, including repeats. Typed SMS replies are not counted.`})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`rcs_unique_replied`})}),_jsx(_components.td,{children:`integer`}),_jsx(_components.td,{children:`Subscriptions that tapped at least one RCS keyword reply button.`})]})]})]}),`\n`,_jsxs(_components.p,{children:[_jsx(_components.code,{children:`rcs_clicked`}),`, `,_jsx(_components.code,{children:`rcs_unique_clicked`}),`, `,_jsx(_components.code,{children:`rcs_replied`}),`, and `,_jsx(_components.code,{children:`rcs_unique_replied`}),` are returned only for apps with RCS access. For other apps, these fields are left out of the response rather than returned as `,_jsx(_components.code,{children:`0`}),`.`]}),`\n`,_jsxs(_components.p,{children:[`To get SMS-only clicks, subtract `,_jsx(_components.code,{children:`rcs_clicked`}),` from `,_jsx(_components.code,{children:`clicks`}),`, or `,_jsx(_components.code,{children:`rcs_unique_clicked`}),` from `,_jsx(_components.code,{children:`unique_clicks`}),`. A recipient’s clicks come from either trackable links or RCS taps, never both, because RCS content does not support trackable links.`]}),`\n`,_jsx(Heading,{level:`3`,id:`rcs-button-activity`,children:`RCS button activity`}),`\n`,_jsxs(_components.p,{children:[`For apps with RCS access, the response for an SMS message also includes a top-level `,_jsx(_components.code,{children:`rcs_element_activity`}),` array with one entry per RCS button. Only this endpoint returns `,_jsx(_components.code,{children:`rcs_element_activity`}),`. `,_jsx(_components.a,{href:`/reference/view-messages`,children:`View messages`}),` does not.`]}),`\n`,_jsxs(Table,{children:[_jsx(_components.thead,{children:_jsxs(_components.tr,{children:[_jsx(_components.th,{children:`Field`}),_jsx(_components.th,{children:`Type`}),_jsx(_components.th,{children:`Description`})]})}),_jsxs(_components.tbody,{children:[_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`id`})}),_jsx(_components.td,{children:`string`}),_jsx(_components.td,{children:`The button’s action ID.`})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`label`})}),_jsx(_components.td,{children:`string`}),_jsx(_components.td,{children:`The button text. Falls back to the action ID when the message content can’t be found, for example after the message was deleted.`})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`card_index`})}),_jsx(_components.td,{children:`integer or null`}),_jsxs(_components.td,{children:[`The button’s card position in a carousel, starting at `,_jsx(_components.code,{children:`0`}),`. `,_jsx(_components.code,{children:`null`}),` for a standalone card.`]})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`action`})}),_jsx(_components.td,{children:`string`}),_jsxs(_components.td,{children:[`The button type: `,_jsx(_components.code,{children:`url`}),`, `,_jsx(_components.code,{children:`phone_number`}),`, or `,_jsx(_components.code,{children:`quick_reply`}),`.`]})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`url`})}),_jsx(_components.td,{children:`string or null`}),_jsxs(_components.td,{children:[`The link destination for a `,_jsx(_components.code,{children:`url`}),` button.`]})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`phone_number`})}),_jsx(_components.td,{children:`string or null`}),_jsxs(_components.td,{children:[`The phone number for a `,_jsx(_components.code,{children:`phone_number`}),` button.`]})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`value`})}),_jsx(_components.td,{children:`string or null`}),_jsxs(_components.td,{children:[`The reply keyword for a `,_jsx(_components.code,{children:`quick_reply`}),` button.`]})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`clicked`})}),_jsx(_components.td,{children:`integer`}),_jsxs(_components.td,{children:[`Total taps on a `,_jsx(_components.code,{children:`url`}),` or `,_jsx(_components.code,{children:`phone_number`}),` button, including repeats.`]})]}),_jsxs(_components.tr,{children:[_jsx(_components.td,{children:_jsx(_components.code,{children:`replied`})}),_jsx(_components.td,{children:`integer`}),_jsxs(_components.td,{children:[`Total taps on a `,_jsx(_components.code,{children:`quick_reply`}),` button, including repeats.`]})]})]})]}),`\n`,_jsx(_components.p,{children:`Button activity counts are totals only. There are no per-button unique counts. A button’s total can be lower than the message-level total.`})]})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent};function _missingMdxReference(id,component){throw new Error(`Expected `+(component?`component`:`object`)+\" `\"+id+\"` to be defined: you likely forgot to import, pass, or provide it.\")}","frontmatter":{},"scope":{"config":{},"pageMetadata":{"title":"View message","openapi":"GET /notifications/{message_id}?app_id={app_id}","keywords":["get message","message stats API","message_id","platform_delivery_stats","outcome_name","RCS analytics","rcs_element_activity","delivery stats"],"description":"View the details of a single message and the Outcomes associated with it.","href":"/reference/view-message"}}},"mdxSourceWithNoJs":null},"mdxExtracts":{"tableOfContents":[{"title":"Overview","slug":"overview","depth":2,"children":[]},{"title":"How to use this API","slug":"how-to-use-this-api","depth":2,"children":[]},{"title":"SMS and RCS analytics fields","slug":"sms-and-rcs-analytics-fields","depth":2,"children":[{"title":"RCS button activity","slug":"rcs-button-activity","depth":3,"children":[]}]}],"codeExamples":{}},"jsLinks":["/_mintlify/custom/onesignal/e069c1b9f3157e14/hotjar-koala.js","/_mintlify/custom/onesignal/3e5d03885ab32f49/intercom.js","/_mintlify/custom/onesignal/dbb7af4794d1b586/munchkin-marketo.js"],"openApiReferenceData":{"operation":{"summary":"View message","description":"View the details of a single message and the Outcomes associated with it.","operationId":"view-message","x-codeSamples":[{"lang":"typescript","label":"Node.js SDK","source":"import Onesignal from '@onesignal/node-onesignal';\n\nconst configuration = Onesignal.createConfiguration({\n restApiKey: 'YOUR_REST_API_KEY',\n});\nconst apiInstance = new Onesignal.DefaultApi(configuration);\n\n// string\nconst appId: string = \"YOUR_APP_ID\";\n// string\nconst notificationId: string = \"b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88\";\n\ntry {\n const response = await apiInstance.getNotification(appId, notificationId);\n console.log(response);\n} catch (e) {\n if (e instanceof Onesignal.ApiException) {\n // `e.errorMessages` flattens any error-envelope shape to a `string[]`;\n // the raw parsed body remains on `e.body`.\n console.error(\"getNotification failed: HTTP \" + e.code, e.errorMessages);\n } else {\n throw e;\n }\n}"},{"lang":"python","label":"Python SDK","source":"import onesignal\nfrom onesignal.api import default_api\nfrom onesignal.models import *\nfrom pprint import pprint\n\n# See configuration.py for a list of all supported configuration parameters.\n# Some of the OneSignal endpoints require ORGANIZATION_API_KEY token for authorization, while others require REST_API_KEY.\n# We recommend adding both of them in the configuration page so that you will not need to figure it out yourself.\nconfiguration = onesignal.Configuration(\n rest_api_key = \"YOUR_REST_API_KEY\", # App REST API key required for most endpoints\n organization_api_key = \"YOUR_ORGANIZATION_API_KEY\" # Organization key is only required for creating new apps and other top-level endpoints\n)\n\n\n# Enter a context with an instance of the API client\nwith onesignal.ApiClient(configuration) as api_client:\n # Create an instance of the API class\n api_instance = default_api.DefaultApi(api_client)\n app_id = \"YOUR_APP_ID\" \n notification_id = \"b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88\" \n\n try:\n # View notification\n api_response = api_instance.get_notification(app_id, notification_id)\n pprint(api_response)\n except onesignal.ApiException as e:\n print(\"Exception when calling DefaultApi->get_notification: %s\\n\" % e)\n print(\"Status Code: %s\" % e.status)\n print(\"Response Body: %s\" % e.body)"},{"lang":"php","label":"PHP SDK","source":"\u003c?php\nrequire_once(__DIR__ . '/vendor/autoload.php');\n\n\n// Configure Bearer authorization: rest_api_key\n$config = onesignal\\client\\Configuration::getDefaultConfiguration()\n ->setRestApiKeyToken('YOUR_REST_API_KEY')\n ->setOrganizationApiKeyToken('YOUR_ORGANIZATION_API_KEY');\n\n\n\n$apiInstance = new onesignal\\client\\Api\\DefaultApi(\n // If you want use custom http client, pass your client which implements `GuzzleHttp\\ClientInterface`.\n // This is optional, `GuzzleHttp\\Client` will be used as default.\n new GuzzleHttp\\Client(),\n $config\n);\n$app_id = 'YOUR_APP_ID'; // string\n$notification_id = 'b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88'; // string\n\ntry {\n $result = $apiInstance->getNotification($app_id, $notification_id);\n print_r($result);\n} catch (\\onesignal\\client\\ApiException $e) {\n echo 'Exception when calling DefaultApi->getNotification: ', $e->getMessage(), PHP_EOL;\n echo 'Status Code: ', $e->getCode(), PHP_EOL;\n // getErrorMessages() flattens any error-envelope shape to a string[];\n // the raw body remains on getResponseBody().\n echo 'Error Messages: ', implode(', ', $e->getErrorMessages()), PHP_EOL;\n echo 'Response Body: ', $e->getResponseBody(), PHP_EOL;\n} catch (\\Exception $e) {\n echo 'Exception when calling DefaultApi->getNotification: ', $e->getMessage(), PHP_EOL;\n}"},{"lang":"go","label":"Go SDK","source":"package main\n\nimport (\n \"context\"\n \"fmt\"\n \"os\"\n\n \"github.com/OneSignal/onesignal-go-api/v5\"\n)\n\nfunc main() {\n appId := \"YOUR_APP_ID\" // string | \n notificationId := \"b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88\" // string | \n\n configuration := onesignal.NewConfiguration()\n apiClient := onesignal.NewAPIClient(configuration)\n\n restAuth := context.WithValue(context.Background(), onesignal.RestApiKey, \"YOUR_REST_API_KEY\") // App REST API key required for most endpoints\n\n resp, r, err := apiClient.DefaultApi.GetNotification(restAuth, notificationId).AppId(appId).Execute()\n\n if err != nil {\n fmt.Fprintf(os.Stderr, \"Error when calling `DefaultApi.GetNotification``: %v\\n\", err)\n fmt.Fprintf(os.Stderr, \"Full HTTP response: %v\\n\", r)\n if apiErr, ok := err.(*onesignal.GenericOpenAPIError); ok {\n // ErrorMessages() flattens any error-envelope shape to a []string;\n // the raw body remains on Body().\n fmt.Fprintf(os.Stderr, \"Error Messages: %v\\n\", apiErr.ErrorMessages())\n fmt.Fprintf(os.Stderr, \"Response Body: %s\\n\", apiErr.Body())\n }\n }\n // response from `GetNotification`: NotificationWithMeta\n fmt.Fprintf(os.Stdout, \"Response from `DefaultApi.GetNotification`: %v\\n\", resp)\n}"},{"lang":"ruby","label":"Ruby SDK","source":"require 'onesignal'\n# setup authorization\nOneSignal.configure do |config|\n # Configure Bearer authorization: rest_api_key\n config.rest_api_key = 'YOUR_REST_API_KEY'\n\nend\n\napi_instance = OneSignal::DefaultApi.new\napp_id = 'YOUR_APP_ID' # String | \nnotification_id = 'b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88' # String | \n\nbegin\n # View notification\n result = api_instance.get_notification(app_id, notification_id)\n p result\nrescue OneSignal::ApiError => e\n puts \"Error when calling DefaultApi->get_notification: #{e}\"\n puts \"Status Code: #{e.code}\"\n # `e.error_messages` flattens any error-envelope shape to an Array\u003cString>;\n # the raw body remains on `e.response_body`.\n puts \"Error Messages: #{e.error_messages}\"\n puts \"Response Body: #{e.response_body}\"\nend"},{"lang":"java","label":"Java SDK","source":"// Import classes:\nimport java.util.Arrays;\nimport java.util.List;\nimport com.onesignal.client.ApiClient;\nimport com.onesignal.client.ApiException;\nimport com.onesignal.client.Configuration;\nimport com.onesignal.client.auth.*;\nimport com.onesignal.client.model.*;\nimport com.onesignal.client.api.DefaultApi;\n\npublic class Example {\n public static void main(String[] args) {\n ApiClient defaultClient = Configuration.getDefaultApiClient();\n defaultClient.setBasePath(\"https://api.onesignal.com\");\n \n // Configure HTTP bearer authorization: rest_api_key\n HttpBearerAuth rest_api_key = (HttpBearerAuth) defaultClient.getAuthentication(\"rest_api_key\");\n rest_api_key.setBearerToken(\"YOUR_REST_API_KEY\");\n\n DefaultApi apiInstance = new DefaultApi(defaultClient);\n String appId = \"YOUR_APP_ID\"; // String | \n String notificationId = \"b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88\"; // String | \n try {\n NotificationWithMeta result = apiInstance.getNotification(appId, notificationId);\n System.out.println(result);\n } catch (ApiException e) {\n System.err.println(\"Exception when calling DefaultApi#getNotification\");\n System.err.println(\"Status code: \" + e.getCode());\n // getErrorMessages() flattens any error-envelope shape to a List\u003cString>;\n // the raw body remains on getResponseBody().\n System.err.println(\"Error messages: \" + e.getErrorMessages());\n System.err.println(\"Reason: \" + e.getResponseBody());\n System.err.println(\"Response headers: \" + e.getResponseHeaders());\n e.printStackTrace();\n }\n }\n}"},{"lang":"csharp","label":"C# SDK","source":"using System;\nusing System.Collections.Generic;\nusing System.Diagnostics;\nusing OneSignalApi.Api;\nusing OneSignalApi.Client;\nusing OneSignalApi.Model;\n\nnamespace Example\n{\n public class GetNotificationExample\n {\n public static void Main()\n {\n Configuration config = new Configuration();\n config.BasePath = \"https://api.onesignal.com\";\n // Configure Bearer token for authorization: rest_api_key\n config.AccessToken = \"YOUR_REST_API_KEY\";\n\n var apiInstance = new DefaultApi(config);\n var appId = \"YOUR_APP_ID\"; // string | \n var notificationId = \"b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88\"; // string | \n\n try\n {\n // View notification\n NotificationWithMeta result = apiInstance.GetNotification(appId, notificationId);\n Debug.WriteLine(result);\n }\n catch (ApiException e)\n {\n Debug.Print(\"Exception when calling DefaultApi.GetNotification: \" + e.Message );\n Debug.Print(\"Status Code: \"+ e.ErrorCode);\n // e.ErrorMessages flattens any error-envelope shape to an IReadOnlyList\u003cstring>;\n // the raw body remains on e.ErrorContent.\n Debug.Print(\"Error Messages: \" + string.Join(\", \", e.ErrorMessages));\n Debug.Print(\"Response Body: \" + e.ErrorContent);\n Debug.Print(e.StackTrace);\n }\n }\n }\n}"},{"lang":"rust","label":"Rust SDK","source":"use onesignal_rust_api::apis::configuration::Configuration;\nuse onesignal_rust_api::apis::default_api;\n\n\n#[tokio::main]\nasync fn main() {\n let mut configuration = Configuration::new();\n configuration.rest_api_key_token = Some(\"YOUR_REST_API_KEY\".to_string());\n\n\n // Realistic values are pulled from the spec's `example:` fields where present.\n let app_id: \u0026str = \"YOUR_APP_ID\";\n let notification_id: \u0026str = \"b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88\";\n\n match default_api::get_notification(\u0026configuration, app_id, notification_id).await {\n Ok(resp) => println!(\"{:?}\", resp),\n Err(e @ onesignal_rust_api::apis::Error::ResponseError(_)) => {\n // `e.error_messages()` flattens any error-envelope shape to a Vec\u003cString>;\n // the raw response remains on the ResponseError variant.\n eprintln!(\"get_notification failed: {:?}\", e.error_messages());\n }\n Err(e) => eprintln!(\"get_notification failed: {:?}\", e),\n }\n}"}],"parameters":["246cb545-3393-4b57-92a0-77f8c55cd3b8","bc9c041d-d32e-4bb8-904a-58bb719dbabb","8e251a6f-0ecf-4f6f-9b37-dfe5c2f09c36","1dca5280-3682-441b-9e17-ce1e36ac9768","300ae803-94f3-433d-9eca-f3f9cae98d57","c079e580-08f1-4b82-9fe9-b0d411d05d1f","f3f7af48-f4ca-4c9e-b1c2-965646e5fbea"],"responses":{"200":"384f269a-5470-402c-b745-335e8b23bfda","429":"230746fe-7101-4ac5-b16f-6cd1e05053fe","503":"f38400d1-afcf-4067-984b-bed7b83d9883"},"deprecated":false,"method":"get","type":"path","servers":["6fd6e670-8369-48b5-ba3d-29f770f2c6b2"],"security":["f1779273-1d58-458a-a5dd-954fcea000a5"],"path":"/notifications/{message_id}?app_id={app_id}","baseUrlOptions":["https://api.onesignal.com"],"title":"View message","codeSamples":[{"label":"Node.js SDK","lang":"typescript","source":"import Onesignal from '@onesignal/node-onesignal';\n\nconst configuration = Onesignal.createConfiguration({\n restApiKey: 'YOUR_REST_API_KEY',\n});\nconst apiInstance = new Onesignal.DefaultApi(configuration);\n\n// string\nconst appId: string = \"YOUR_APP_ID\";\n// string\nconst notificationId: string = \"b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88\";\n\ntry {\n const response = await apiInstance.getNotification(appId, notificationId);\n console.log(response);\n} catch (e) {\n if (e instanceof Onesignal.ApiException) {\n // `e.errorMessages` flattens any error-envelope shape to a `string[]`;\n // the raw parsed body remains on `e.body`.\n console.error(\"getNotification failed: HTTP \" + e.code, e.errorMessages);\n } else {\n throw e;\n }\n}"},{"label":"Python SDK","lang":"python","source":"import onesignal\nfrom onesignal.api import default_api\nfrom onesignal.models import *\nfrom pprint import pprint\n\n# See configuration.py for a list of all supported configuration parameters.\n# Some of the OneSignal endpoints require ORGANIZATION_API_KEY token for authorization, while others require REST_API_KEY.\n# We recommend adding both of them in the configuration page so that you will not need to figure it out yourself.\nconfiguration = onesignal.Configuration(\n rest_api_key = \"YOUR_REST_API_KEY\", # App REST API key required for most endpoints\n organization_api_key = \"YOUR_ORGANIZATION_API_KEY\" # Organization key is only required for creating new apps and other top-level endpoints\n)\n\n\n# Enter a context with an instance of the API client\nwith onesignal.ApiClient(configuration) as api_client:\n # Create an instance of the API class\n api_instance = default_api.DefaultApi(api_client)\n app_id = \"YOUR_APP_ID\" \n notification_id = \"b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88\" \n\n try:\n # View notification\n api_response = api_instance.get_notification(app_id, notification_id)\n pprint(api_response)\n except onesignal.ApiException as e:\n print(\"Exception when calling DefaultApi->get_notification: %s\\n\" % e)\n print(\"Status Code: %s\" % e.status)\n print(\"Response Body: %s\" % e.body)"},{"label":"PHP SDK","lang":"php","source":"\u003c?php\nrequire_once(__DIR__ . '/vendor/autoload.php');\n\n\n// Configure Bearer authorization: rest_api_key\n$config = onesignal\\client\\Configuration::getDefaultConfiguration()\n ->setRestApiKeyToken('YOUR_REST_API_KEY')\n ->setOrganizationApiKeyToken('YOUR_ORGANIZATION_API_KEY');\n\n\n\n$apiInstance = new onesignal\\client\\Api\\DefaultApi(\n // If you want use custom http client, pass your client which implements `GuzzleHttp\\ClientInterface`.\n // This is optional, `GuzzleHttp\\Client` will be used as default.\n new GuzzleHttp\\Client(),\n $config\n);\n$app_id = 'YOUR_APP_ID'; // string\n$notification_id = 'b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88'; // string\n\ntry {\n $result = $apiInstance->getNotification($app_id, $notification_id);\n print_r($result);\n} catch (\\onesignal\\client\\ApiException $e) {\n echo 'Exception when calling DefaultApi->getNotification: ', $e->getMessage(), PHP_EOL;\n echo 'Status Code: ', $e->getCode(), PHP_EOL;\n // getErrorMessages() flattens any error-envelope shape to a string[];\n // the raw body remains on getResponseBody().\n echo 'Error Messages: ', implode(', ', $e->getErrorMessages()), PHP_EOL;\n echo 'Response Body: ', $e->getResponseBody(), PHP_EOL;\n} catch (\\Exception $e) {\n echo 'Exception when calling DefaultApi->getNotification: ', $e->getMessage(), PHP_EOL;\n}"},{"label":"Go SDK","lang":"go","source":"package main\n\nimport (\n \"context\"\n \"fmt\"\n \"os\"\n\n \"github.com/OneSignal/onesignal-go-api/v5\"\n)\n\nfunc main() {\n appId := \"YOUR_APP_ID\" // string | \n notificationId := \"b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88\" // string | \n\n configuration := onesignal.NewConfiguration()\n apiClient := onesignal.NewAPIClient(configuration)\n\n restAuth := context.WithValue(context.Background(), onesignal.RestApiKey, \"YOUR_REST_API_KEY\") // App REST API key required for most endpoints\n\n resp, r, err := apiClient.DefaultApi.GetNotification(restAuth, notificationId).AppId(appId).Execute()\n\n if err != nil {\n fmt.Fprintf(os.Stderr, \"Error when calling `DefaultApi.GetNotification``: %v\\n\", err)\n fmt.Fprintf(os.Stderr, \"Full HTTP response: %v\\n\", r)\n if apiErr, ok := err.(*onesignal.GenericOpenAPIError); ok {\n // ErrorMessages() flattens any error-envelope shape to a []string;\n // the raw body remains on Body().\n fmt.Fprintf(os.Stderr, \"Error Messages: %v\\n\", apiErr.ErrorMessages())\n fmt.Fprintf(os.Stderr, \"Response Body: %s\\n\", apiErr.Body())\n }\n }\n // response from `GetNotification`: NotificationWithMeta\n fmt.Fprintf(os.Stdout, \"Response from `DefaultApi.GetNotification`: %v\\n\", resp)\n}"},{"label":"Ruby SDK","lang":"ruby","source":"require 'onesignal'\n# setup authorization\nOneSignal.configure do |config|\n # Configure Bearer authorization: rest_api_key\n config.rest_api_key = 'YOUR_REST_API_KEY'\n\nend\n\napi_instance = OneSignal::DefaultApi.new\napp_id = 'YOUR_APP_ID' # String | \nnotification_id = 'b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88' # String | \n\nbegin\n # View notification\n result = api_instance.get_notification(app_id, notification_id)\n p result\nrescue OneSignal::ApiError => e\n puts \"Error when calling DefaultApi->get_notification: #{e}\"\n puts \"Status Code: #{e.code}\"\n # `e.error_messages` flattens any error-envelope shape to an Array\u003cString>;\n # the raw body remains on `e.response_body`.\n puts \"Error Messages: #{e.error_messages}\"\n puts \"Response Body: #{e.response_body}\"\nend"},{"label":"Java SDK","lang":"java","source":"// Import classes:\nimport java.util.Arrays;\nimport java.util.List;\nimport com.onesignal.client.ApiClient;\nimport com.onesignal.client.ApiException;\nimport com.onesignal.client.Configuration;\nimport com.onesignal.client.auth.*;\nimport com.onesignal.client.model.*;\nimport com.onesignal.client.api.DefaultApi;\n\npublic class Example {\n public static void main(String[] args) {\n ApiClient defaultClient = Configuration.getDefaultApiClient();\n defaultClient.setBasePath(\"https://api.onesignal.com\");\n \n // Configure HTTP bearer authorization: rest_api_key\n HttpBearerAuth rest_api_key = (HttpBearerAuth) defaultClient.getAuthentication(\"rest_api_key\");\n rest_api_key.setBearerToken(\"YOUR_REST_API_KEY\");\n\n DefaultApi apiInstance = new DefaultApi(defaultClient);\n String appId = \"YOUR_APP_ID\"; // String | \n String notificationId = \"b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88\"; // String | \n try {\n NotificationWithMeta result = apiInstance.getNotification(appId, notificationId);\n System.out.println(result);\n } catch (ApiException e) {\n System.err.println(\"Exception when calling DefaultApi#getNotification\");\n System.err.println(\"Status code: \" + e.getCode());\n // getErrorMessages() flattens any error-envelope shape to a List\u003cString>;\n // the raw body remains on getResponseBody().\n System.err.println(\"Error messages: \" + e.getErrorMessages());\n System.err.println(\"Reason: \" + e.getResponseBody());\n System.err.println(\"Response headers: \" + e.getResponseHeaders());\n e.printStackTrace();\n }\n }\n}"},{"label":"C# SDK","lang":"csharp","source":"using System;\nusing System.Collections.Generic;\nusing System.Diagnostics;\nusing OneSignalApi.Api;\nusing OneSignalApi.Client;\nusing OneSignalApi.Model;\n\nnamespace Example\n{\n public class GetNotificationExample\n {\n public static void Main()\n {\n Configuration config = new Configuration();\n config.BasePath = \"https://api.onesignal.com\";\n // Configure Bearer token for authorization: rest_api_key\n config.AccessToken = \"YOUR_REST_API_KEY\";\n\n var apiInstance = new DefaultApi(config);\n var appId = \"YOUR_APP_ID\"; // string | \n var notificationId = \"b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88\"; // string | \n\n try\n {\n // View notification\n NotificationWithMeta result = apiInstance.GetNotification(appId, notificationId);\n Debug.WriteLine(result);\n }\n catch (ApiException e)\n {\n Debug.Print(\"Exception when calling DefaultApi.GetNotification: \" + e.Message );\n Debug.Print(\"Status Code: \"+ e.ErrorCode);\n // e.ErrorMessages flattens any error-envelope shape to an IReadOnlyList\u003cstring>;\n // the raw body remains on e.ErrorContent.\n Debug.Print(\"Error Messages: \" + string.Join(\", \", e.ErrorMessages));\n Debug.Print(\"Response Body: \" + e.ErrorContent);\n Debug.Print(e.StackTrace);\n }\n }\n }\n}"},{"label":"Rust SDK","lang":"rust","source":"use onesignal_rust_api::apis::configuration::Configuration;\nuse onesignal_rust_api::apis::default_api;\n\n\n#[tokio::main]\nasync fn main() {\n let mut configuration = Configuration::new();\n configuration.rest_api_key_token = Some(\"YOUR_REST_API_KEY\".to_string());\n\n\n // Realistic values are pulled from the spec's `example:` fields where present.\n let app_id: \u0026str = \"YOUR_APP_ID\";\n let notification_id: \u0026str = \"b3a0c8bd-3a4c-4b22-9a73-3f1a8c2d1b88\";\n\n match default_api::get_notification(\u0026configuration, app_id, notification_id).await {\n Ok(resp) => println!(\"{:?}\", resp),\n Err(e @ onesignal_rust_api::apis::Error::ResponseError(_)) => {\n // `e.error_messages()` flattens any error-envelope shape to a Vec\u003cString>;\n // the raw response remains on the ResponseError variant.\n eprintln!(\"get_notification failed: {:?}\", e.error_messages());\n }\n Err(e) => eprintln!(\"get_notification failed: {:?}\", e),\n }\n}"}],"requestExampleLanguages":["bash","typescript","python","php","go","ruby","java","csharp","rust"],"requiredOnlyExamples":false,"requestExampleType":"codeSamples","responseExampleType":"generated"},"dependencies":{"parameters":{"246cb545-3393-4b57-92a0-77f8c55cd3b8":{"name":"message_id","in":"path","description":"The identifier of the message in UUID v4 format. Get this `id` in the response of your Create Message API request, the [View Messages API](/reference/view-messages), and in your OneSignal dashboard Message Reports.","schema":{"type":"string","isRequired":true,"description":"The identifier of the message in UUID v4 format. Get this `id` in the response of your Create Message API request, the [View Messages API](/reference/view-messages), and in your OneSignal dashboard Message Reports.","uniqueKey":"","typeLabel":"string"},"required":true},"bc9c041d-d32e-4bb8-904a-58bb719dbabb":{"name":"app_id","in":"query","description":"Your OneSignal App ID in UUID v4 format. See [Keys \u0026 IDs](/docs/en/keys-and-ids).","required":true,"schema":{"type":"string","default":"YOUR_APP_ID","isRequired":true,"description":"Your OneSignal App ID in UUID v4 format. See [Keys \u0026 IDs](/docs/en/keys-and-ids).","uniqueKey":"","typeLabel":"string"}},"8e251a6f-0ecf-4f6f-9b37-dfe5c2f09c36":{"name":"Authorization","in":"header","description":"Your App API key with prefix `Key `. See [Keys \u0026 IDs](/docs/en/keys-and-ids).","required":true,"schema":{"type":"string","default":"Key YOUR_APP_API_KEY","isRequired":true,"description":"Your App API key with prefix `Key `. See [Keys \u0026 IDs](/docs/en/keys-and-ids).","uniqueKey":"","typeLabel":"string"}},"1dca5280-3682-441b-9e17-ce1e36ac9768":{"name":"outcome_names","in":"query","description":"The name and aggregation type of the outcome(s) you want to fetch. Example: `my_outcome.count` or `my_outcome.sum`. For clicks, use `os__click.count`. For confirmed deliveries, use `os__confirmed_delivery.count`. For session duration, use `os__session_duration.count`.","schema":{"type":"array","items":{"type":"string","default":["os__click.count","os__confirmed_delivery.count","os__session_duration.count"],"uniqueKey":"items.[INDEX]","typeLabel":"string"},"description":"The name and aggregation type of the outcome(s) you want to fetch. Example: `my_outcome.count` or `my_outcome.sum`. For clicks, use `os__click.count`. For confirmed deliveries, use `os__confirmed_delivery.count`. For session duration, use `os__session_duration.count`.","uniqueKey":"","typeLabel":"string[]"}},"300ae803-94f3-433d-9eca-f3f9cae98d57":{"name":"outcome_time_range","in":"query","description":"Time range for the returned data. Available values: `1h` (1 hour), `1d` (1 day), `1mo` (1 month)","schema":{"type":"string","enum":["1h","1d","1mo"],"default":"1h","description":"Time range for the returned data. Available values: `1h` (1 hour), `1d` (1 day), `1mo` (1 month)","uniqueKey":"","typeLabel":"enum\u003cstring>"}},"c079e580-08f1-4b82-9fe9-b0d411d05d1f":{"name":"outcome_platforms","in":"query","description":"The platforms in which you want to pull the data represented as the `device_type` integer.","schema":{"type":"string","default":"0,1,2,5,8,11,14,17","description":"The platforms in which you want to pull the data represented as the `device_type` integer.","uniqueKey":"","typeLabel":"string"}},"f3f7af48-f4ca-4c9e-b1c2-965646e5fbea":{"name":"outcome_attribution","in":"query","description":"Attribution type for the outcomes.","schema":{"type":"string","enum":["direct","influenced","unattributed","total"],"default":"total","description":"Attribution type for the outcomes.","uniqueKey":"","typeLabel":"enum\u003cstring>"}}},"responses":{"384f269a-5470-402c-b745-335e8b23bfda":{"description":"200","content":{"application/json":{"schema":{"type":"object","description":"Returns all message properties set. See the [Push notifications](/reference/push-notification), [Email](/reference/email), and/or [SMS](/reference/sms) Message Create APIs for all properties. Most commonly used properties for this endpoint are listed.","properties":{"app_id":{"type":"string","description":"Your OneSignal App ID in UUID v4 format. See [Keys \u0026 IDs](/docs/en/keys-and-ids).","uniqueKey":"app_id","typeLabel":"string"},"big_picture":{"description":"The URL of the image set in the push notification.","type":"string","uniqueKey":"big_picture","typeLabel":"string"},"canceled":{"description":"Whether the message was canceled.","type":"boolean","uniqueKey":"canceled","typeLabel":"boolean"},"chrome_web_icon":{"description":"The URL of the icon set in the push notification.","type":"string","uniqueKey":"chrome_web_icon","typeLabel":"string"},"chrome_web_image":{"description":"The URL of the image set in the push notification.","type":"string","uniqueKey":"chrome_web_image","typeLabel":"string"},"name":{"type":"string","description":"An internal name you set to help organize and track messages. Not shown to recipients. Maximum 128 characters.","uniqueKey":"name","typeLabel":"string"},"contents":{"description":"The main message body with [language-specific values](/docs/en/multi-language-messaging#supported-languages).","type":"object","properties":{"en":{"type":"string","description":"The required message language type. See [Supported Languages](/docs/en/multi-language-messaging#supported-languages).","uniqueKey":"contents.en","typeLabel":"string"}},"uniqueKey":"contents","typeLabel":"object"},"converted":{"type":"integer","description":"The number of times the push was clicked.","uniqueKey":"converted","typeLabel":"integer"},"data":{"type":"object","description":"The JSON data set in the push notification if applicable.","uniqueKey":"data","typeLabel":"object"},"delayed_option":{"type":"string","description":"The per-user delay option set for the message.","uniqueKey":"delayed_option","typeLabel":"string"},"delivery_time_of_day":{"type":"string","description":"The delivery time of day set for the message if `delayed_option` is `timezone`.","uniqueKey":"delivery_time_of_day","typeLabel":"string"},"remaining":{"type":"integer","description":"The number of messages that have not been sent yet. If `null`, then the system is still processing the audience, try again later.","uniqueKey":"remaining","typeLabel":"integer"},"errored":{"type":"integer","description":"The number of times the message errored.","uniqueKey":"errored","typeLabel":"integer"},"excluded_segments":{"type":"array","description":"The segments excluded from the message if applicable.","uniqueKey":"excluded_segments","typeLabel":"array"},"failed":{"type":"integer","description":"The number of subscriptions reported unsubscribed for the message.","uniqueKey":"failed","typeLabel":"integer"},"global_image":{"description":"The URL of the image set in the push notification.","type":"string","uniqueKey":"global_image","typeLabel":"string"},"headings":{"type":"object","description":"The title of the push notification.","uniqueKey":"headings","typeLabel":"object"},"id":{"type":"string","description":"The identifier of the message in UUID v4 format.","uniqueKey":"id","typeLabel":"string"},"included_segments":{"type":"array","description":"The segments included in the message if applicable.","uniqueKey":"included_segments","typeLabel":"array"},"ios_badgeCount":{"type":"integer","description":"The badge count set for the message if applicable.","uniqueKey":"ios_badgeCount","typeLabel":"integer"},"ios_badgeType":{"type":"string","description":"The badge type set for the message if applicable.","uniqueKey":"ios_badgeType","typeLabel":"string"},"queued_at":{"type":"integer","description":"Unix timestamp of when the message was created.","uniqueKey":"queued_at","typeLabel":"integer"},"send_after":{"type":"integer","description":"Unix timestamp of when the message delivery was scheduled to begin.","uniqueKey":"send_after","typeLabel":"integer"},"completed_at":{"type":"integer","description":"Unix timestamp of when the message delivery was completed. The delivery duration from start to finish can be calculated with `completed_at - send_after`. ","uniqueKey":"completed_at","typeLabel":"integer"},"successful":{"type":"integer","description":"The number of messages successfully delivered to the push, email, or SMS servers.","uniqueKey":"successful","typeLabel":"integer"},"received":{"type":"integer","description":"The number of messages that confirmed being received aka [Confirmed Deliveries](/docs/en/confirmed-delivery).","uniqueKey":"received","typeLabel":"integer"},"filters":{"type":"object","description":"The filters set for the message if applicable.","uniqueKey":"filters","typeLabel":"object"},"template_id":{"type":"string","description":"The template ID in UUID v4 format set for the message if applicable. See [Templates](/docs/en/templates).","uniqueKey":"template_id","typeLabel":"string"},"url":{"type":"string","description":"The URL of the push notification.","uniqueKey":"url","typeLabel":"string"},"web_url":{"type":"string","description":"The URL of the push notification for web push subscriptions.","uniqueKey":"web_url","typeLabel":"string"},"app_url":{"type":"string","description":"The URL of the push notification for mobile subscriptions.","uniqueKey":"app_url","typeLabel":"string"},"platform_delivery_stats":{"type":"object","description":"The successful, errored, failed, converted, received and frequency cap counts for each platform applicable.","uniqueKey":"platform_delivery_stats","typeLabel":"object"},"throttle_rate_per_minute":{"type":"number","description":"The throttle rate of the push notification if applicable.","uniqueKey":"throttle_rate_per_minute","typeLabel":"number"},"fcap_status":{"type":"string","description":"The frequency cap status of the push notification if applicable.","uniqueKey":"fcap_status","typeLabel":"string"},"outcomes":{"type":"object","description":"The id, value, and aggregation type of the outcome set in the request.","uniqueKey":"outcomes","typeLabel":"object"},"kind":{"type":"string","enum":["warmup"],"description":"Present when this message is an [Auto Warm Up](/docs/en/email-warm-up) campaign.","uniqueKey":"kind","typeLabel":"enum\u003cstring>"},"email_warm_up":{"type":"object","description":"The Auto Warm Up campaign's stage schedule, strategy, and live status. Present only when `kind` is `warmup`. See [Auto Warm Up](/docs/en/email-warm-up).","properties":{"stages":{"type":"array","description":"The campaign's sending schedule, stage by stage.","items":{"type":"object","properties":{"start":{"type":"string","description":"ISO 8601 timestamp for the start of this stage.","uniqueKey":"email_warm_up.stages.items.[INDEX].start","typeLabel":"string"},"end":{"type":"string","description":"ISO 8601 timestamp for the end of this stage.","uniqueKey":"email_warm_up.stages.items.[INDEX].end","typeLabel":"string"},"quota":{"type":"integer","description":"Number of emails to send during this stage.","uniqueKey":"email_warm_up.stages.items.[INDEX].quota","typeLabel":"integer"},"acked":{"type":"boolean","description":"Whether this stage has been picked up by the warm-up scheduler.","uniqueKey":"email_warm_up.stages.items.[INDEX].acked","typeLabel":"boolean"}},"uniqueKey":"email_warm_up.stages.items.[INDEX]","typeLabel":"object"},"uniqueKey":"email_warm_up.stages","typeLabel":"object[]"},"strategy":{"type":"string","enum":["recommended","custom"],"description":"Whether the stage schedule was generated by OneSignal (`recommended`) or provided as-is in the create request (`custom`).","uniqueKey":"email_warm_up.strategy","typeLabel":"enum\u003cstring>"},"status":{"type":"string","enum":["initializing","draft","active","finished","canceled"],"description":"The campaign's current status.","uniqueKey":"email_warm_up.status","typeLabel":"enum\u003cstring>"},"is_live":{"type":"boolean","description":"Whether the campaign is currently sending.","uniqueKey":"email_warm_up.is_live","typeLabel":"boolean"}},"uniqueKey":"email_warm_up","typeLabel":"object"}},"uniqueKey":"","typeLabel":"object"},"examples":{"Example":{"title":"Example","value":{"app_id":"\u003cstring>","big_picture":"\u003cstring>","canceled":true,"chrome_web_icon":"\u003cstring>","chrome_web_image":"\u003cstring>","name":"\u003cstring>","contents":{"en":"\u003cstring>"},"converted":123,"data":{},"delayed_option":"\u003cstring>","delivery_time_of_day":"\u003cstring>","remaining":123,"errored":123,"excluded_segments":"\u003carray>","failed":123,"global_image":"\u003cstring>","headings":{},"id":"\u003cstring>","included_segments":"\u003carray>","ios_badgeCount":123,"ios_badgeType":"\u003cstring>","queued_at":123,"send_after":123,"completed_at":123,"successful":123,"received":123,"filters":{},"template_id":"\u003cstring>","url":"\u003cstring>","web_url":"\u003cstring>","app_url":"\u003cstring>","platform_delivery_stats":{},"throttle_rate_per_minute":123,"fcap_status":"\u003cstring>","outcomes":{},"kind":"warmup","email_warm_up":{"stages":[{"start":"\u003cstring>","end":"\u003cstring>","quota":123,"acked":true}],"strategy":"recommended","status":"initializing","is_live":true}}}},"exampleType":"generated"}},"exampleType":"generated"},"230746fe-7101-4ac5-b16f-6cd1e05053fe":{"description":"Rate limit exceeded. Wait the number of seconds in the `Retry-After` header before retrying.","headers":{"Retry-After":{"description":"Number of seconds to wait before retrying the request. Always emitted on 429 responses.","schema":{"type":"integer","minimum":0}}},"content":{"application/json":{"schema":{"type":"object","properties":{"errors":{"type":"array","items":{"type":"string","uniqueKey":"errors.items.[INDEX]","typeLabel":"string"},"description":"One or more human-readable error messages.","uniqueKey":"errors","typeLabel":"string[]"},"success":{"type":"boolean","description":"Present (and `false`) on some endpoints (notifications, templates, segments). Not emitted by every endpoint.","uniqueKey":"success","typeLabel":"boolean"},"reference":{"type":"array","items":{"type":"string","uniqueKey":"reference.items.[INDEX]","typeLabel":"string"},"description":"Documentation URL fragments related to the error. Only emitted by the API-key auth error helpers.","uniqueKey":"reference","typeLabel":"string[]"}},"uniqueKey":"","typeLabel":"object"},"example":{"errors":["API rate limit exceeded"]},"examples":{"Example":{"title":"Example","value":{"errors":["API rate limit exceeded"]}}},"exampleType":"examples"}},"exampleType":"examples"},"f38400d1-afcf-4067-984b-bed7b83d9883":{"description":"Service temporarily unavailable. Retry after a short backoff. The body may be empty or non-JSON in some failure modes.","headers":{"Retry-After":{"description":"Number of seconds to wait before retrying the request. This header is optional and may be absent when a proxy or load balancer generates the 503.","schema":{"type":"integer","minimum":0}}},"content":{"application/json":{"schema":{"type":"object","properties":{"errors":{"type":"array","items":{"type":"string","uniqueKey":"errors.items.[INDEX]","typeLabel":"string"},"description":"One or more human-readable error messages.","uniqueKey":"errors","typeLabel":"string[]"},"success":{"type":"boolean","description":"Present (and `false`) on some endpoints (notifications, templates, segments). Not emitted by every endpoint.","uniqueKey":"success","typeLabel":"boolean"},"reference":{"type":"array","items":{"type":"string","uniqueKey":"reference.items.[INDEX]","typeLabel":"string"},"description":"Documentation URL fragments related to the error. Only emitted by the API-key auth error helpers.","uniqueKey":"reference","typeLabel":"string[]"}},"uniqueKey":"","typeLabel":"object"},"example":{"errors":["Service temporarily unavailable"]},"examples":{"Example":{"title":"Example","value":{"errors":["Service temporarily unavailable"]}}},"exampleType":"examples"}},"exampleType":"examples"}},"security":{"f1779273-1d58-458a-a5dd-954fcea000a5":{}},"servers":{"6fd6e670-8369-48b5-ba3d-29f770f2c6b2":{"url":"https://api.onesignal.com"}}},"originalFileLocation":"openapi.json"},"subdomain":"onesignal","siteName":"OneSignal Documentation","title":"View message - OneSignal Documentation","navMaps":{"firstHrefInVersion":{},"firstHrefInLanguage":{"en":{"href":"/reference/view-message","matchLevel":0},"cn":{"href":"/reference/view-message","matchLevel":0},"ko":{"href":"/reference/view-message","matchLevel":0},"ja":{"href":"/reference/view-message","matchLevel":0},"tr":{"href":"/reference/view-message","matchLevel":0},"pt-BR":{"href":"/reference/view-message","matchLevel":0},"es":{"href":"/reference/view-message","matchLevel":0},"fr":{"href":"/reference/view-message","matchLevel":0}}},"lastModified":"2026-11-12T18:23:37.084Z","originalFileLocation":"reference/view-message.mdx","locale":"en"},"headHtml":"\u003cscript data-mint-head>(function(){var d=document.documentElement,p=null;if(!p){try{p=localStorage.getItem(\"isDarkMode\")}catch(e){}if(p==='true')p='dark';else if(p==='false')p='light';if(p!=='light'\u0026\u0026p!=='dark'\u0026\u0026p!=='system')p=\"system\"}var r=p==='system'?(matchMedia(\"(prefers-color-scheme: dark)\").matches?'dark':'light'):p;d.classList.remove(r==='dark'?'light':'dark');d.classList.add(r);d.setAttribute(\"data-theme-preference\",p)})();\u003c/script>\u003cmeta data-mint-head name=\"description\" content=\"View the details of a single message and the Outcomes associated with it.\">\u003cmeta data-mint-head name=\"application-name\" content=\"OneSignal Documentation\">\u003cmeta data-mint-head name=\"generator\" content=\"Mintlify\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"192x192\" href=\"/mintlify-assets/_mintlify/favicons/onesignal/eCiRydtW5fLfLRWp/_generated/favicon/android-chrome-192x192.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"apple-touch-icon\" type=\"image/png\" sizes=\"180x180\" href=\"/mintlify-assets/_mintlify/favicons/onesignal/eCiRydtW5fLfLRWp/_generated/favicon/apple-touch-icon.png\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"16x16\" href=\"/mintlify-assets/_mintlify/favicons/onesignal/eCiRydtW5fLfLRWp/_generated/favicon/favicon-16x16.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"32x32\" href=\"/mintlify-assets/_mintlify/favicons/onesignal/eCiRydtW5fLfLRWp/_generated/favicon/favicon-32x32.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"shortcut icon\" type=\"image/x-icon\" href=\"/mintlify-assets/_mintlify/favicons/onesignal/eCiRydtW5fLfLRWp/_generated/favicon/favicon.ico\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"192x192\" href=\"/mintlify-assets/_mintlify/favicons/onesignal/eCiRydtW5fLfLRWp/_generated/favicon-dark/android-chrome-192x192.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"16x16\" href=\"/mintlify-assets/_mintlify/favicons/onesignal/eCiRydtW5fLfLRWp/_generated/favicon-dark/favicon-16x16.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"32x32\" href=\"/mintlify-assets/_mintlify/favicons/onesignal/eCiRydtW5fLfLRWp/_generated/favicon-dark/favicon-32x32.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"shortcut icon\" type=\"image/x-icon\" href=\"/mintlify-assets/_mintlify/favicons/onesignal/eCiRydtW5fLfLRWp/_generated/favicon-dark/favicon.ico\" media=\"(prefers-color-scheme: dark)\">\u003cmeta data-mint-head property=\"og:title\" content=\"View message - OneSignal Documentation\">\u003cmeta data-mint-head property=\"og:description\" content=\"View the details of a single message and the Outcomes associated with it.\">\u003cmeta data-mint-head property=\"og:site_name\" content=\"OneSignal Documentation\">\u003cmeta data-mint-head property=\"og:url\" content=\"https://documentation.onesignal.com/reference/view-message\">\u003cmeta data-mint-head property=\"og:type\" content=\"website\">\u003cmeta data-mint-head property=\"og:image\" content=\"https://onesignal.mintlify.site/_mintlify/api/og/v2?division=Messages\u0026amp;title=View+message\u0026amp;description=View+the+details+of+a+single+message+and+the+Outcomes+associated+with+it.\u0026amp;theme=12e705baa88dc8cc6d7a9877\u0026amp;signature=0ec8346075f2e9baa078840641155574ce58c11aee90266389db3ae04c1371cd\">\u003cmeta data-mint-head property=\"og:image:width\" content=\"1200\">\u003cmeta data-mint-head property=\"og:image:height\" content=\"630\">\u003cmeta data-mint-head name=\"twitter:card\" content=\"summary_large_image\">\u003cmeta data-mint-head name=\"twitter:title\" content=\"View message - OneSignal Documentation\">\u003cmeta data-mint-head name=\"twitter:description\" content=\"View the details of a single message and the Outcomes associated with it.\">\u003cmeta data-mint-head name=\"twitter:image\" content=\"https://onesignal.mintlify.site/_mintlify/api/og/v2?division=Messages\u0026amp;title=View+message\u0026amp;description=View+the+details+of+a+single+message+and+the+Outcomes+associated+with+it.\u0026amp;theme=12e705baa88dc8cc6d7a9877\u0026amp;signature=0ec8346075f2e9baa078840641155574ce58c11aee90266389db3ae04c1371cd\">\u003cmeta data-mint-head name=\"twitter:image:width\" content=\"1200\">\u003cmeta data-mint-head name=\"twitter:image:height\" content=\"630\">\u003cmeta data-mint-head name=\"msapplication-config\" content=\"/mintlify-assets/_mintlify/favicons/onesignal/eCiRydtW5fLfLRWp/_generated/favicon/browserconfig.xml\">\u003cmeta data-mint-head name=\"apple-mobile-web-app-title\" content=\"OneSignal Docs\">\u003cmeta data-mint-head name=\"msapplication-TileColor\" content=\"#3A3DB3\">\u003clink data-mint-head rel=\"canonical\" href=\"https://documentation.onesignal.com/reference/view-message\">\u003clink data-mint-head rel=\"alternate\" type=\"application/xml\" href=\"/sitemap.xml\">\u003clink data-mint-head rel=\"alternate\" type=\"text/markdown\" href=\"/reference/view-message.md\">\u003cscript data-mint-head type=\"application/ld+json\">{\"@context\":\"https://schema.org\",\"@graph\":[{\"@type\":\"Organization\",\"@id\":\"https://documentation.onesignal.com/#organization\",\"name\":\"OneSignal Documentation\",\"url\":\"https://documentation.onesignal.com\",\"logo\":{\"@type\":\"ImageObject\",\"url\":\"https://mintcdn.com/onesignal/yJcueeDCO7UpHnnY/logo/OneSignal-Logo.svg?fit=max\u0026auto=format\u0026n=yJcueeDCO7UpHnnY\u0026q=85\u0026s=1fcfb6fef6d820fd9d99c74850711107\"}},{\"@type\":\"WebSite\",\"@id\":\"https://documentation.onesignal.com#website\",\"name\":\"OneSignal Documentation\",\"url\":\"https://documentation.onesignal.com\",\"publisher\":{\"@id\":\"https://documentation.onesignal.com/#organization\"}},{\"@type\":\"WebPage\",\"@id\":\"https://documentation.onesignal.com/reference/view-message#webpage\",\"url\":\"https://documentation.onesignal.com/reference/view-message\",\"name\":\"View message\",\"description\":\"View the details of a single message and the Outcomes associated with it.\",\"dateModified\":\"2026-11-12T18:23:37.084Z\",\"isPartOf\":{\"@id\":\"https://documentation.onesignal.com#website\"},\"breadcrumb\":{\"@id\":\"https://documentation.onesignal.com/reference/view-message#breadcrumb\"}},{\"@type\":\"BreadcrumbList\",\"@id\":\"https://documentation.onesignal.com/reference/view-message#breadcrumb\",\"itemListElement\":[{\"@type\":\"ListItem\",\"position\":1,\"name\":\"API reference\",\"item\":\"https://documentation.onesignal.com/reference/create-message\"},{\"@type\":\"ListItem\",\"position\":2,\"name\":\"Messages\",\"item\":\"https://documentation.onesignal.com/reference/create-message\"},{\"@type\":\"ListItem\",\"position\":3,\"name\":\"View message\",\"item\":\"https://documentation.onesignal.com/reference/view-message\"}]},{\"@type\":[\"TechArticle\",\"APIReference\"],\"@id\":\"https://documentation.onesignal.com/reference/view-message#apireference\",\"headline\":\"View message\",\"name\":\"View message\",\"description\":\"View the details of a single message and the Outcomes associated with it.\",\"url\":\"https://documentation.onesignal.com/reference/view-message\",\"mainEntityOfPage\":{\"@id\":\"https://documentation.onesignal.com/reference/view-message#webpage\"},\"dateModified\":\"2026-11-12T18:23:37.084Z\",\"keywords\":\"get message, message stats API, message_id, platform_delivery_stats, outcome_name, RCS analytics, rcs_element_activity, delivery stats\",\"publisher\":{\"@id\":\"https://documentation.onesignal.com/#organization\"},\"isPartOf\":{\"@id\":\"https://documentation.onesignal.com#website\"}}]}\u003c/script>\u003cscript data-mint-head type=\"application/ld+json\">{\"@context\":\"https://schema.org\",\"@type\":\"WebSite\",\"name\":\"OneSignal Documentation\",\"publisher\":{\"@type\":\"Organization\",\"name\":\"OneSignal Documentation\"},\"provider\":{\"@type\":\"Organization\",\"name\":\"Mintlify\",\"url\":\"https://mintlify.com\"}}\u003c/script>","agentPointerHref":"/reference/view-message.md","siteName":"OneSignal Documentation","nav":{"global":null,"languages":[{"language":"en","tabs":[{"tab":"Home","pages":[{"title":"Home","href":"/docs/en/home"}]},{"tab":"User Guides","pages":[{"title":"User Guides","href":"/docs/en/quickstart-guide"}]},{"tab":"Developer Guides","pages":[{"title":"Developer Guides","href":"/docs/en/developers"}]},{"tab":"Tutorials","pages":[{"title":"Tutorials","href":"/docs/en/tutorials"}]},{"tab":"API Reference","groups":[{"group":"Using the REST APIs","pages":[{"title":"REST API overview","href":"/reference/rest-api-overview"},{"title":"Rate limits and error handling","href":"/reference/rate-limits"},{"title":"Idempotent API requests","href":"/reference/idempotent-notification-requests"},{"title":"Server SDK reference","href":"/docs/en/server-sdk-reference"}]},{"group":"API reference","pages":[{"group":"Messages","pages":[{"title":"Sending messages with the OneSignal API","href":"/reference/create-message"},{"title":"Push notification","openapi":"POST /notifications?c=push","href":"/reference/push-notification"},{"title":"Email","openapi":"POST /notifications?c=email","href":"/reference/email"},{"title":"SMS","openapi":"POST /notifications?c=sms","description":"Send a message using the SMS channel.","href":"/reference/sms"},{"title":"View message","openapi":"GET /notifications/{message_id}?app_id={app_id}","href":"/reference/view-message"},{"title":"View me
[...]
